/* This file stores the logic to make the on-board LED blink
The following libraries are needed:
-. Arduino.h: includes Arduino specific commands for coding
-. wifi-mqtt.h: allows to connect to your WIFI and to the MQTT broker. Also allow for publish and subscribe from it.
-. delay.h: allows to get the delay value from the platform
-. topics_publish.h: stores the topic to publish the data to
Reference: arduino.cc
*/

#include <Arduino.h>
#include <wifi-mqtt.h>
#include <delay.h>
#include <topics_publish.h>

//Define the structure to send the data to the led_blink property in the platform in json format.
String json_payload_off = "{ \"led_blink\":\"Off\" }";
String json_payload_on= "{ \"led_blink\":\"On\" }";

// Turn on defines the logic to turn the LED on
void turn_on(){
//Define an auxiliar variable to convert the payload message to char.
    char json_char_on[200]; 
    json_payload_on.toCharArray(json_char_on, 200);

    digitalWrite(LED_BUILTIN, HIGH); // Turns on the LED by supplying 5 volts to the LED anode
    wifi_mqtt_send(json_char_on,publishTopic_data); // Publish a message to the raw history section
    wifi_mqtt_send(json_char_on,publishTopic); // Publish a message to the property topic
    Serial.println("on"); // Message to check the led is on at PlatformIO Serial Monitor
    delay(return_delay()); // Set the delay based on the value enter in the delay property in SmartWorks IoT platform
    
 }

// Turn off defines the logic to turn the LED off
void turn_off(){ 
//Define an auxiliar variable to convert the payload message to char
    char json_char_off[200];
    json_payload_off.toCharArray(json_char_off, 200);

    digitalWrite(LED_BUILTIN, LOW);// Turns off the LED by supplying 0 volts 
    wifi_mqtt_send(json_char_off,publishTopic); // Publish a message to the raw history section
    wifi_mqtt_send(json_char_off,publishTopic_data); // Publish a message to the property topic
    Serial.println("off"); // Message to check the led is off at PlatformIO Serial Monitor
    delay(return_delay()); // Set the delay based on the value enter in the delay property in SmartWorks IoT platform
}