/* This file stores the logic to capture humidity data from the DHT11 sensor connected to Arduino board
The following libraries are needed:
-. Arduino.h: includes Arduino specific commands for coding
-. wifi-mqtt.h: allows to connect to your WIFI and to the MQTT broker. Also allow for publish and subscribe from it.
-. delay.h: allows to get the delay value from the platform
-. topics_humidity_publish.h: stores the topic to publish the data to
Reference: arduino.cc
*/
#include <Arduino.h>
#include <wifi-mqtt.h>
#include <delay.h>
#include <topics_humidity_publish.h>
#include <DHT.h>

#define DHTPIN 2
#define DHTTYPE DHT11
DHT dht(DHTPIN, DHTTYPE);

//Define the structure to send the data to the humidity property in the platform in json format.
char json_humidity_data[] = "{ \"humidity\":\"%i\" }";

void humidity(){
    dht.begin();
    int h = dht.readHumidity();
    char json_char_humidity[100]="";
    snprintf(json_char_humidity, sizeof(json_char_humidity), json_humidity_data, h);
    wifi_mqtt_send(json_char_humidity,publishHumidityTopic_data);// Publish a message to the raw history section
    wifi_mqtt_send(json_char_humidity,publishHumidityTopic);// Publish a message to the property topic
    Serial.println(json_humidity_data);
    delay(return_delay());
}